import os
from google.appengine.api import images
from google.appengine.api.images import Image
from google.appengine.ext import webapp
from google.appengine.ext.webapp import template
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.api import users
from google.appengine.ext import db
from google.appengine.api import memcache
from _elementtree import ElementTree
from Utils import getCurrentUserOwner
from Utils import parseBoolString
from json import JsonReader
from json import ReadException
from json import WriteException

class ActualImage(webapp.RequestHandler):
    def get(self):
        currentUser = getCurrentUserOwner()
        
        requestedImage = db.get(self.request.get("id"))
        canDisplayImage = False
        if requestedImage.public:
            canDisplayImage = True
        elif not currentUser is None:
            if requestedImage.owner.key() == currentUser.key():
                canDisplayImage = True
        if canDisplayImage:
            self.response.headers['Content-Type'] = "image/png"
            self.response.out.write(requestedImage.image)

    def delete(self):
       currentUser = getCurrentUserOwner()
       if not currentUser is None:
           requestedImage = db.get(self.request.get("id"))
           if requestedImage.owner.key() == currentUser.key():
               db.delete(requestedImage)

    def post(self):
       reader = JsonReader()
       currentUser = getCurrentUserOwner()
       tempImage = reader.read(self.request.body)
       if not currentUser is None:
           requestedImage = db.get(tempImage['key'])
           if requestedImage.owner.key() == currentUser.key():
               requestedImage.caption = tempImage['caption']
               requestedImage.description = tempImage['description']
               requestedImage.public = tempImage['public']
               requestedImage.put()               
