import os
from google.appengine.api import images
from google.appengine.api.images import Image
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.api import users
from google.appengine.ext import db
from google.appengine.api import memcache
from _elementtree import ElementTree
from Utils import getCurrentUserOwner
from Utils import parseBoolString
from json import JsonWriter
from json import ReadException
from json import WriteException
from ImageFile import ImageFile 

class ImageList(webapp.RequestHandler):
    def get(self):
        username = ""
        # Get the current user
        owner = getCurrentUserOwner()
        if (not owner is None):
            # The user is known. Fetch the first 1000 photos
            images = db.GqlQuery(
                      "SELECT * FROM ImageFile WHERE owner=:1", 
                      owner).fetch(1000, 0)
            imageList = []
            
            # Create temp objects that only 
            # contain the info we need to be sent to
            # the caller. 
            for image in images:
                key = image.key()
                temp = {'key': str(key), 
                        'caption': str(image.caption), 
                        'description':str(image.description),
                        'public': str(image.public)}
                imageList.append(temp)
            # Write the objects to a string and send them on
            # back
            writer = JsonWriter()
            imageResponse = writer.write(imageList)
            self.response.headers['Content-Type'] = \
             "application/json"
            self.response.out.write(imageResponse)
                
def post(self):
    currentUser = getCurrentUserOwner()
    if currentUser is None:
        return
    
    image = ImageFile()
    uploaded = self.request.body
    image.image = db.Blob(images.resize(uploaded, 300, 300))
    image.owner = currentUser
    image.public = False
    image.put()
