import os
from google.appengine.api import images
from google.appengine.api.images import Image
from google.appengine.ext import webapp
from google.appengine.ext.webapp import template
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.api import users
from google.appengine.ext import db
from google.appengine.api import memcache
from _elementtree import ElementTree
from Utils import getCurrentUserOwner
from ImageFile import ImageFile

class MainPage(webapp.RequestHandler):
    def get(self):

        loggedIn = False
        username = "test"
        currentUser = users.get_current_user()
        images = None
        if currentUser:
            url = users.create_logout_url(self.request.uri)
            url_linktext = 'Logout'
            loggedIn = True
            username = currentUser.nickname().strip()
            if (len(username) < 1):
                username = currentUser.email().strip()
            owner = getCurrentUserOwner()
            if (owner is None):
                owner = Owner()
                owner.name = username
                db.put(owner)
            else:
                images = db.GqlQuery("SELECT * FROM ImageFile WHERE owner=:1", owner)
        else:
            url = users.create_login_url(self.request.uri)
            url_linktext = 'Login'

        template_values = {
            'url': url,
            'url_linktext': url_linktext,
            'loggedIn': loggedIn,
            'username': username,
            'images':images,
            }
        
        path = os.path.join(os.path.dirname(__file__), 'pages/index.html')
        self.response.out.write(template.render(path, template_values))

