﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Runtime.Serialization;
using System.Json;
using System.Collections.Generic;
using System.ComponentModel;

namespace PhotoWebSL
{
    [DataContract(Namespace = "http://www.scottseely.com/RESTBook/2008")]
    public class ImageItem : INotifyPropertyChanged
    {
        public static string BaseUri { get; set; }
        public ImageItem() { }

        public string ImageUrl
        {
            get
            {
                return string.Format("{0}?id={1}", BaseUri, ImageId);
            }
        }

        string _caption;
        [DataMember(Name = "caption")]
        public string Caption
        {
            get { return _caption; }
            set
            {
                _caption = value;
                NotifyChange("Caption");
            }
        }


        string _description;
        [DataMember(Name="description")]
        public string Description
        {
            get { return _description; }
            set
            {
                _description = value; 
                NotifyChange("Description");
            }
        }

        [DataMember(Name = "key")]
        public string ImageId { get; set; }


        bool _publicImage;
        [DataMember(Name="public")]
        public bool PublicImage
        {
            get { return _publicImage; }
            set
            {
                _publicImage = value; 
                NotifyChange("PublicImage");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        void NotifyChange(string property)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(property));
            }
        }
    }

    public class UpdateImageRequest
    {
        [DataMember(Name = "item")]
        public ImageItem Item { get; set; }

        [DataMember(Name = "key")]
        public string ImageId { get; set; }

        public JsonValue ToJsonValue
        {
            get
            {
                List<KeyValuePair<string, JsonValue>> jsonValues = new List<KeyValuePair<string, JsonValue>>();
                List<KeyValuePair<string, JsonValue>> jsonRetval = new List<KeyValuePair<string, JsonValue>>();
                jsonValues.Add(new KeyValuePair<string, JsonValue>("Caption", Item.Caption));
                jsonValues.Add(new KeyValuePair<string, JsonValue>("Description", Item.Description));
                jsonValues.Add(new KeyValuePair<string, JsonValue>("PublicImage", Item.PublicImage));
                jsonRetval.Add(new KeyValuePair<string, JsonValue>("imageId", ImageId));
                jsonRetval.Add(new KeyValuePair<string, JsonValue>("item", new JsonObject(jsonValues)));
                return new JsonObject(jsonRetval);
            }
        }
    }
}
